package com.qmth.exam.reserve.controller.student;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.exam.reserve.bean.RichTextBean;
import com.qmth.exam.reserve.bean.apply.ApplyTimePeriodResult;
import com.qmth.exam.reserve.bean.apply.ApplyVO;
import com.qmth.exam.reserve.bean.apply.TicketInfo;
import com.qmth.exam.reserve.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController("stuApplyController")
@Api(tags = "考生预约相关接口")
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/student")
@Aac(strict = false, auth = true)
public class StudentApplyController extends BaseController {

    private static final Logger log = LoggerFactory.getLogger(StudentApplyController.class);

    @ApiOperation(value = "保存考生预约结果")
    @PostMapping(value = "/apply/save")
    public void save(@ApiParam("考点ID") @RequestParam Long examSiteId,
                     @ApiParam("预约时段ID") @RequestParam Long timePeriodId) {
        //todo
    }

    @ApiOperation(value = "取消考生预约结果")
    @PostMapping(value = "/apply/cancel")
    public void cancel(@ApiParam("预约ID") @RequestParam Long applyId) {
        //todo
    }

    @ApiOperation(value = "获取考生预约结果列表（个人中心）")
    @PostMapping(value = "/apply/list")
    public List<ApplyVO> list(@ApiParam("包含状态：多个值逗号分隔；不填时代表全部状态") @RequestParam String includeStatus) {
        //todo
        return new ArrayList<>();
    }

    @ApiOperation(value = "获取考生当前进行中的预约列表（首页）")
    @PostMapping(value = "/apply/list/for/current")
    public List<ApplyVO> listForCurrent() {
        //todo
        return new ArrayList<>();
    }

    @ApiOperation(value = "获取考生预约-电子准考证")
    @PostMapping(value = "/apply/ticket")
    public TicketInfo ticket(@ApiParam("预约ID") @RequestParam Long applyId) {
        //todo
        return new TicketInfo();
    }

    @ApiOperation(value = "获取考试须知")
    @PostMapping(value = "/exam/notice")
    public RichTextBean examNotice(@ApiParam("预约ID") @RequestParam Long applyId) {
        //todo
        return new RichTextBean();
    }

    @ApiOperation(value = "获取考场引导")
    @PostMapping(value = "/exam/room/guide")
    public RichTextBean examRoomGuide(@ApiParam("预约ID") @RequestParam Long applyId) {
        //todo
        return new RichTextBean();
    }

    @ApiOperation(value = "获取可预约的“日期”列表")
    @PostMapping(value = "/apply/date/list")
    public List<String> dateList() {
        List<String> dateList = new ArrayList<>();
        dateList.add("20240401");
        //todo
        return dateList;
    }

    @ApiOperation(value = "获取可预约的“时段”列表")
    @PostMapping(value = "/apply/time/period/list")
    public ApplyTimePeriodResult timePeriodList(@ApiParam("考点ID") @RequestParam Long examSiteId,
                                                @ApiParam("预约日期：yyyyMMdd") @RequestParam String date) {
        ApplyTimePeriodResult result = new ApplyTimePeriodResult();
        //todo
        return result;
    }

}
